/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 21 "../../../phaver/src/parser.yy" /* yacc.c:339  */

#include "convex_clock_val_set.hh"
#include "clock_val_set.hh"
#include "stopwatch.hh"
#include "symb_states_type.hh"
#include "automaton.hh"

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <fstream>
#include <memory>
#include <string>

#ifndef NDEBUG
#define YYDEBUG 1
#endif

#include "parser.hh"

extern FILE* yyin;
int yylex();

void
yyerror(const std::string& str) {
  std::cout << "Parse error in line " << line_number << ": ";
  std::cout << str << "\n";
  exit(1);
}

inline int
atoi_consume(const std::string* ptr) {
  int res = atoi(ptr->c_str());
  delete ptr;
  return res;
}

inline void
check_ident_consume(const std::string* ptr,
                    const std::string& expected) {
  const auto& parsed = *ptr;
  if (parsed != expected)
    yyerror("Expecting `" + expected + "', found `" + parsed + "'.");
  delete ptr;
}

void
parse_file(const std::string& filename) {
  /* doesn't deal with recursive loads */
  yyin = fopen(filename.c_str(), "r");
  if (yyin == nullptr) {
    std::cout << "*** Error opening `" << filename << "' ***\n";
    exit(1);
  }
  stopwatch sw(2001, "file " + filename);
  line_number = 1;
  yyparse();
  fclose(yyin);
}

Cons
identity_dpost(dim_type dim, const var_ref_set& contr_vars) {
  Cons dpost;
  for (auto vid : contr_vars)
    dpost.push_back(Var(vid) == Var(vid + dim));
  return dpost;
}

void
check_dpost(dim_type dim, const Cons& dpost,
            const var_ref_set& contr_vars) {
  var_ref_set seen;
  for (const auto& c : dpost)
    for (auto j = c.space_dim(); j-- > dim; ) {
      if (c.coeff(Var(j)) != 0)
        seen.insert(j - dim);
    }
  if (seen != contr_vars)
    yyerror("Discrete post does not mention a controlled variable.");
}

automaton* paut;
symb_states_type* psymb_state;
dim_type val_set_dim;

using RAE_Map = std::map<std::string, Rat_Affine_Expr>;
RAE_Map rae_map;

// Note: these are NON-owning (automaton) pointers.
using SS_Map = std::map<std::string, std::pair<symb_states_type, automaton*>>;
SS_Map ss_map;

// Note: these are owning (automaton) pointers.
using PAUT_Map = std::map<std::string, std::unique_ptr<automaton>>;
PAUT_Map paut_map;

std::string outfilename = "out";
std::ofstream file_out;
std::string current_loc_name;

using std::string;
using std::make_pair;
using std::cout;
using std::endl;

using pplite::Con;
using pplite::Cons;


#line 176 "parser.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_PARSER_HH_INCLUDED
# define YY_YY_PARSER_HH_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    MERGE_SPLITTED = 258,
    ASAP = 259,
    par_TIME_POST_ITER = 260,
    par_TIME_POST_CONE_LAMBDA = 261,
    par_TIME_POST_CONE_WIDEN_DELAY = 262,
    par_TIME_POST_CONE_WIDEN_PRECISION = 263,
    par_MEMORY_MODE = 264,
    par_REACH_CHEAP_CONTAINS = 265,
    par_REACH_CHEAP_CONTAINS_USE_BBOX = 266,
    par_REACH_USE_BBOX = 267,
    par_REACH_USE_CONSTRAINT_HULL = 268,
    par_REACH_USE_CONVEX_HULL = 269,
    par_REACH_USE_TIME_ELAPSE = 270,
    par_REACH_STOP_AT_FORB = 271,
    par_REACH_MAX_ITER = 272,
    par_REACH_REPORT_INTERVAL = 273,
    par_REACH_USE_BBOX_ITER = 274,
    par_REACH_STOP_USE_CONVEX_HULL_ITER = 275,
    par_REACH_STOP_USE_CONVEX_HULL_SETTLE = 276,
    par_REACH_CONSTRAINT_LIMIT = 277,
    par_LIMIT_CONSTRAINTS_METHOD = 278,
    par_TP_CONSTRAINT_LIMIT = 279,
    par_REACH_CONSTRAINT_TRIGGER = 280,
    par_REACH_BITSIZE_TRIGGER = 281,
    par_CONSTRAINT_BITSIZE = 282,
    par_SEARCH_METHOD = 283,
    par_SNAPSHOT_INTERVAL = 284,
    par_REFINE_DERIVATIVE_METHOD = 285,
    par_REFINE_PRIORITIZE_REACH_SPLIT = 286,
    par_REFINE_SMALLEST_FIRST = 287,
    par_REFINE_USE_FP = 288,
    par_REFINE_DERIV_MINANGLE = 289,
    par_REFINE_PRIORITIZE_ANGLE = 290,
    par_REFINE_CHECK_TIME_RELEVANCE = 291,
    par_REFINE_CHECK_TIME_RELEVANCE_DURING = 292,
    par_REFINE_CHECK_TIME_RELEVANCE_FINAL = 293,
    par_REFINE_CHECK_TRANS_DIMS = 294,
    par_REFINE_PARTITION_INSIDE = 295,
    par_REACH_FB_REFINE_METHOD = 296,
    par_REFINE_LOCATION_PLANE = 297,
    par_REFINE_MAX_CHECKS = 298,
    par_REFINE_USE_NEW_SPLIT = 299,
    par_MINIMIZE_FILTER_THRESHOLD = 300,
    PROJECT_TO = 301,
    DIFFERENCE_ASSIGN = 302,
    RENAME = 303,
    IS_REACHABLE = 304,
    IS_REACHABLE_FB = 305,
    INVARIANT_ASSIGN = 306,
    REVERSE = 307,
    SAVE_FP_SURFACE = 308,
    REACH_FORWARD_ITER = 309,
    UNLOCK_SURFACE_LOCS = 310,
    UNLOCK_LOCS = 311,
    GET_INVARIANTS = 312,
    PRINT_GRAPH = 313,
    PROJECT_TO_FIRST = 314,
    INVERSE = 315,
    CONTAINS = 316,
    REFINE_CONSTRAINTS = 317,
    ADD_LABEL = 318,
    WHO = 319,
    SAVE_FP_INVARS = 320,
    INITIAL_STATES = 321,
    REFINE_LOCS = 322,
    REFINE_LOC_DERIV = 323,
    IS_EMPTY = 324,
    INTERSECTION_ASSIGN = 325,
    LOC_INTERSECTION = 326,
    LOC_UNION = 327,
    REMOVE = 328,
    MY_ECHO = 329,
    GET_PARAMETERS = 330,
    PRINT = 331,
    SAVE_CON_FP = 332,
    SAVE_GEN_FP = 333,
    REACH = 334,
    REACH_STOP = 335,
    DEFNE = 336,
    AUTOMATON = 337,
    INTERNAL_VAR = 338,
    EXTERNAL_VAR = 339,
    PARAMETER = 340,
    SYNCLABS = 341,
    INITIALLY = 342,
    LOC = 343,
    WHILE = 344,
    WHEN = 345,
    END = 346,
    TRUE = 347,
    FALSE = 348,
    ASSIGN = 349,
    INT = 350,
    IDENT = 351,
    STARIDENT = 352,
    STRING_TEXT = 353,
    GE = 354,
    LE = 355,
    EQ = 356,
    PRIM = 357
  };
#endif
/* Tokens.  */
#define MERGE_SPLITTED 258
#define ASAP 259
#define par_TIME_POST_ITER 260
#define par_TIME_POST_CONE_LAMBDA 261
#define par_TIME_POST_CONE_WIDEN_DELAY 262
#define par_TIME_POST_CONE_WIDEN_PRECISION 263
#define par_MEMORY_MODE 264
#define par_REACH_CHEAP_CONTAINS 265
#define par_REACH_CHEAP_CONTAINS_USE_BBOX 266
#define par_REACH_USE_BBOX 267
#define par_REACH_USE_CONSTRAINT_HULL 268
#define par_REACH_USE_CONVEX_HULL 269
#define par_REACH_USE_TIME_ELAPSE 270
#define par_REACH_STOP_AT_FORB 271
#define par_REACH_MAX_ITER 272
#define par_REACH_REPORT_INTERVAL 273
#define par_REACH_USE_BBOX_ITER 274
#define par_REACH_STOP_USE_CONVEX_HULL_ITER 275
#define par_REACH_STOP_USE_CONVEX_HULL_SETTLE 276
#define par_REACH_CONSTRAINT_LIMIT 277
#define par_LIMIT_CONSTRAINTS_METHOD 278
#define par_TP_CONSTRAINT_LIMIT 279
#define par_REACH_CONSTRAINT_TRIGGER 280
#define par_REACH_BITSIZE_TRIGGER 281
#define par_CONSTRAINT_BITSIZE 282
#define par_SEARCH_METHOD 283
#define par_SNAPSHOT_INTERVAL 284
#define par_REFINE_DERIVATIVE_METHOD 285
#define par_REFINE_PRIORITIZE_REACH_SPLIT 286
#define par_REFINE_SMALLEST_FIRST 287
#define par_REFINE_USE_FP 288
#define par_REFINE_DERIV_MINANGLE 289
#define par_REFINE_PRIORITIZE_ANGLE 290
#define par_REFINE_CHECK_TIME_RELEVANCE 291
#define par_REFINE_CHECK_TIME_RELEVANCE_DURING 292
#define par_REFINE_CHECK_TIME_RELEVANCE_FINAL 293
#define par_REFINE_CHECK_TRANS_DIMS 294
#define par_REFINE_PARTITION_INSIDE 295
#define par_REACH_FB_REFINE_METHOD 296
#define par_REFINE_LOCATION_PLANE 297
#define par_REFINE_MAX_CHECKS 298
#define par_REFINE_USE_NEW_SPLIT 299
#define par_MINIMIZE_FILTER_THRESHOLD 300
#define PROJECT_TO 301
#define DIFFERENCE_ASSIGN 302
#define RENAME 303
#define IS_REACHABLE 304
#define IS_REACHABLE_FB 305
#define INVARIANT_ASSIGN 306
#define REVERSE 307
#define SAVE_FP_SURFACE 308
#define REACH_FORWARD_ITER 309
#define UNLOCK_SURFACE_LOCS 310
#define UNLOCK_LOCS 311
#define GET_INVARIANTS 312
#define PRINT_GRAPH 313
#define PROJECT_TO_FIRST 314
#define INVERSE 315
#define CONTAINS 316
#define REFINE_CONSTRAINTS 317
#define ADD_LABEL 318
#define WHO 319
#define SAVE_FP_INVARS 320
#define INITIAL_STATES 321
#define REFINE_LOCS 322
#define REFINE_LOC_DERIV 323
#define IS_EMPTY 324
#define INTERSECTION_ASSIGN 325
#define LOC_INTERSECTION 326
#define LOC_UNION 327
#define REMOVE 328
#define MY_ECHO 329
#define GET_PARAMETERS 330
#define PRINT 331
#define SAVE_CON_FP 332
#define SAVE_GEN_FP 333
#define REACH 334
#define REACH_STOP 335
#define DEFNE 336
#define AUTOMATON 337
#define INTERNAL_VAR 338
#define EXTERNAL_VAR 339
#define PARAMETER 340
#define SYNCLABS 341
#define INITIALLY 342
#define LOC 343
#define WHILE 344
#define WHEN 345
#define END 346
#define TRUE 347
#define FALSE 348
#define ASSIGN 349
#define INT 350
#define IDENT 351
#define STARIDENT 352
#define STRING_TEXT 353
#define GE 354
#define LE 355
#define EQ 356
#define PRIM 357

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 131 "../../../phaver/src/parser.yy" /* yacc.c:355  */

 std::string* mystring;
 pplite::Con* con;
 pplite::Cons* con_list;
 RefinementCon* refinement_con;
 RefinementCons* refinement_cons;
 var_ref_set* vrs;
 clock_val_set* cvs;
 std::list<std::string>* ident_list;
 bool mybool;
 Rat_Affine_Expr* rae;
 symb_states_type* symb_state;

#line 434 "parser.cc" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_PARSER_HH_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 451 "parser.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  100
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   615

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  123
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  46
/* YYNRULES -- Number of rules.  */
#define YYNRULES  180
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  556

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   357

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   110,     2,     2,     2,     2,   100,     2,
     111,   112,   108,   106,   117,   107,   116,   109,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   122,   114,
     104,   115,   105,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   118,     2,   119,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   120,    99,   121,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,   101,   102,   103,   113
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   275,   275,   278,   279,   283,   284,   288,   290,   312,
     327,   349,   389,   408,   407,   425,   424,   449,   448,   478,
     500,   511,   522,   536,   550,   562,   576,   590,   607,   619,
     637,   664,   678,   693,   692,   724,   733,   744,   757,   769,
     788,   807,   833,   860,   887,   893,   924,   934,   933,   947,
     959,   971,   986,   998,  1026,  1049,  1058,  1060,  1065,  1067,
    1069,  1072,  1074,  1076,  1078,  1080,  1082,  1084,  1086,  1088,
    1090,  1092,  1094,  1096,  1098,  1100,  1102,  1104,  1106,  1108,
    1114,  1116,  1118,  1120,  1122,  1124,  1126,  1144,  1147,  1149,
    1151,  1153,  1155,  1157,  1159,  1161,  1163,  1165,  1170,  1171,
    1176,  1175,  1189,  1192,  1194,  1195,  1196,  1197,  1201,  1215,
    1219,  1223,  1227,  1233,  1242,  1248,  1257,  1263,  1272,  1278,
    1285,  1295,  1307,  1313,  1326,  1331,  1339,  1352,  1368,  1369,
    1370,  1371,  1375,  1378,  1394,  1395,  1399,  1401,  1403,  1408,
    1423,  1438,  1452,  1468,  1484,  1501,  1507,  1516,  1526,  1540,
    1540,  1550,  1550,  1560,  1566,  1572,  1577,  1581,  1592,  1600,
    1603,  1609,  1620,  1631,  1642,  1657,  1666,  1675,  1684,  1693,
    1702,  1707,  1715,  1722,  1736,  1758,  1768,  1776,  1782,  1788,
    1793
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "MERGE_SPLITTED", "ASAP",
  "par_TIME_POST_ITER", "par_TIME_POST_CONE_LAMBDA",
  "par_TIME_POST_CONE_WIDEN_DELAY", "par_TIME_POST_CONE_WIDEN_PRECISION",
  "par_MEMORY_MODE", "par_REACH_CHEAP_CONTAINS",
  "par_REACH_CHEAP_CONTAINS_USE_BBOX", "par_REACH_USE_BBOX",
  "par_REACH_USE_CONSTRAINT_HULL", "par_REACH_USE_CONVEX_HULL",
  "par_REACH_USE_TIME_ELAPSE", "par_REACH_STOP_AT_FORB",
  "par_REACH_MAX_ITER", "par_REACH_REPORT_INTERVAL",
  "par_REACH_USE_BBOX_ITER", "par_REACH_STOP_USE_CONVEX_HULL_ITER",
  "par_REACH_STOP_USE_CONVEX_HULL_SETTLE", "par_REACH_CONSTRAINT_LIMIT",
  "par_LIMIT_CONSTRAINTS_METHOD", "par_TP_CONSTRAINT_LIMIT",
  "par_REACH_CONSTRAINT_TRIGGER", "par_REACH_BITSIZE_TRIGGER",
  "par_CONSTRAINT_BITSIZE", "par_SEARCH_METHOD", "par_SNAPSHOT_INTERVAL",
  "par_REFINE_DERIVATIVE_METHOD", "par_REFINE_PRIORITIZE_REACH_SPLIT",
  "par_REFINE_SMALLEST_FIRST", "par_REFINE_USE_FP",
  "par_REFINE_DERIV_MINANGLE", "par_REFINE_PRIORITIZE_ANGLE",
  "par_REFINE_CHECK_TIME_RELEVANCE",
  "par_REFINE_CHECK_TIME_RELEVANCE_DURING",
  "par_REFINE_CHECK_TIME_RELEVANCE_FINAL", "par_REFINE_CHECK_TRANS_DIMS",
  "par_REFINE_PARTITION_INSIDE", "par_REACH_FB_REFINE_METHOD",
  "par_REFINE_LOCATION_PLANE", "par_REFINE_MAX_CHECKS",
  "par_REFINE_USE_NEW_SPLIT", "par_MINIMIZE_FILTER_THRESHOLD",
  "PROJECT_TO", "DIFFERENCE_ASSIGN", "RENAME", "IS_REACHABLE",
  "IS_REACHABLE_FB", "INVARIANT_ASSIGN", "REVERSE", "SAVE_FP_SURFACE",
  "REACH_FORWARD_ITER", "UNLOCK_SURFACE_LOCS", "UNLOCK_LOCS",
  "GET_INVARIANTS", "PRINT_GRAPH", "PROJECT_TO_FIRST", "INVERSE",
  "CONTAINS", "REFINE_CONSTRAINTS", "ADD_LABEL", "WHO", "SAVE_FP_INVARS",
  "INITIAL_STATES", "REFINE_LOCS", "REFINE_LOC_DERIV", "IS_EMPTY",
  "INTERSECTION_ASSIGN", "LOC_INTERSECTION", "LOC_UNION", "REMOVE",
  "MY_ECHO", "GET_PARAMETERS", "PRINT", "SAVE_CON_FP", "SAVE_GEN_FP",
  "REACH", "REACH_STOP", "DEFNE", "AUTOMATON", "INTERNAL_VAR",
  "EXTERNAL_VAR", "PARAMETER", "SYNCLABS", "INITIALLY", "LOC", "WHILE",
  "WHEN", "END", "TRUE", "FALSE", "ASSIGN", "INT", "IDENT", "STARIDENT",
  "STRING_TEXT", "'|'", "'&'", "GE", "LE", "EQ", "'<'", "'>'", "'+'",
  "'-'", "'*'", "'/'", "'!'", "'('", "')'", "PRIM", "';'", "'='", "'.'",
  "','", "'['", "']'", "'{'", "'}'", "':'", "$accept", "program",
  "commands", "command", "$@1", "$@2", "$@3", "$@4", "$@5", "var_ref_list",
  "prelim", "bool_type", "automaton", "$@6", "automaton_body",
  "declaration", "synclab", "internal_vars", "external_vars", "parameters",
  "ivar_list", "evar_list", "param_list", "ident_list", "compose_list",
  "initial", "state_list", "location_list", "WAIT", "location",
  "transition_list", "SYNC", "DO", "GOTO", "transition", "refinement_cons",
  "refinement_con", "state_val_set", "$@7", "post_val_set", "$@8",
  "val_set", "constr_list", "constr_list_no_and", "constr", "rat_aff_expr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   124,
      38,   354,   355,   356,    60,    62,    43,    45,    42,    47,
      33,    40,    41,   357,    59,    61,    46,    44,    91,    93,
     123,   125,    58
};
# endif

#define YYPACT_NINF -470

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-470)))

#define YYTABLE_NINF -139

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     175,   -92,   -72,   -59,   -24,   -22,     0,    11,    32,    34,
      43,    61,   132,   140,   158,   159,   165,   167,   174,   183,
     190,   194,   196,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -6,   201,   236,   176,   -89,   281,   175,  -470,
    -470,  -470,   253,    39,   254,   255,   256,   -86,   -86,   -86,
     -86,   -86,   -86,   -86,   -44,   257,   258,   259,   -86,   260,
     -86,   261,   262,   263,   264,   265,   266,   267,   -86,   -86,
     -86,    39,   -86,   -86,   -86,   -86,   -86,   -86,   268,   269,
     270,   -86,   272,  -470,   211,   273,  -470,    39,   274,    51,
    -470,  -470,   271,  -470,   275,    39,    39,   134,   277,   278,
     279,  -470,  -470,   280,   282,   283,   284,   285,   286,   287,
     288,   276,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   161,   305,
     311,   312,   314,   315,   316,   317,   318,   319,   320,   321,
    -470,   251,  -470,   170,   -33,   -18,   325,   326,   327,   328,
     329,   330,   331,   332,   333,  -470,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    64,   347,   306,   334,  -470,
    -470,  -470,   188,    39,    39,    39,    39,  -470,  -470,  -470,
    -470,  -470,  -470,  -470,  -470,  -470,  -470,  -470,  -470,   344,
    -470,  -470,  -470,  -470,  -470,  -470,  -470,  -470,  -470,  -470,
    -470,  -470,  -470,  -470,  -470,  -470,  -470,  -470,  -470,  -470,
    -470,  -470,  -470,  -470,  -470,  -470,  -470,  -470,   -86,   348,
     168,  -470,   354,  -470,     5,   355,  -470,   359,   363,   364,
    -470,   368,   371,  -470,   370,   373,   360,   374,   375,   376,
     378,  -470,  -470,   379,  -470,  -470,   380,  -470,   381,   365,
     366,  -470,    16,    16,  -470,  -470,  -470,   369,  -470,   250,
     252,   358,   361,   386,  -470,  -470,  -470,  -470,   150,   372,
    -470,   377,   382,   383,   384,   385,   387,   388,   389,   117,
     367,  -470,   392,   390,   393,   394,   396,   395,   397,   399,
     401,   402,   403,   -12,   404,   400,   405,   415,   415,   406,
     422,   423,   425,   426,   362,   -76,  -470,   409,  -470,   398,
    -470,   429,   430,   432,  -470,  -470,  -470,  -470,   433,  -470,
     434,   414,   435,   418,   419,   420,  -470,   421,    39,   424,
    -470,   428,   431,   436,   437,   440,   438,   442,   439,  -470,
      31,   113,  -470,  -470,   112,  -470,   203,  -470,   204,   427,
     205,   407,   443,   434,   209,  -470,   398,   398,  -470,  -470,
     444,   445,   446,   447,   -27,  -470,   448,  -470,  -470,  -470,
     441,  -470,   127,   -10,  -470,  -470,  -470,  -470,   449,  -470,
     450,  -470,   451,   452,   453,  -470,   458,  -470,   459,  -470,
     467,   426,  -470,   468,  -470,  -470,   210,  -470,   472,   398,
      -1,    44,   455,   456,   457,   460,   461,   462,   415,    39,
     465,  -470,   454,   464,  -470,  -470,  -470,  -470,  -470,  -470,
     166,   463,   476,  -470,  -470,   473,   483,   466,   426,   469,
    -470,  -470,    44,    44,   146,  -470,  -470,   157,  -470,  -470,
    -470,  -470,  -470,  -470,   189,   115,   470,   475,  -470,  -470,
     426,  -470,   471,  -470,   426,   474,   -32,  -470,  -470,    53,
      65,    44,    44,    39,    39,    39,    39,    39,   478,  -470,
      39,  -470,   479,   191,    49,  -470,   -32,  -470,   484,   477,
     485,   417,    49,  -470,  -470,  -470,   207,    55,   207,   184,
     207,   486,   195,  -470,  -470,   -34,  -470,   480,   489,   481,
    -470,   482,   492,   490,    39,    39,    39,    39,   487,  -470,
      49,  -470,  -470,   491,   492,   488,  -470,  -470,   426,   207,
     207,   207,   207,   493,  -470,   494,  -470,   426,   496,    -7,
    -470,   496,    -7,  -470,   502,   505,   507,   508,   497,   498,
     499,   500,  -470,  -470,  -470,  -470
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     2,     4,
       5,     6,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     8,     0,     0,   100,     0,     0,    15,
       1,     3,     0,   172,   174,     0,     0,     0,     0,     0,
       0,    98,    99,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       7,     0,   103,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    47,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    56,
     173,   179,     0,     0,     0,     0,     0,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,     0,
      70,    71,    72,    73,    81,    74,    82,    83,    84,    85,
      86,    87,    75,    76,    77,    78,    79,    80,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,     0,     0,
       0,    55,     0,     9,    13,     0,    30,     0,     0,     0,
      35,     0,     0,    52,     0,     0,     0,     0,     0,     0,
       0,    44,    28,     0,    21,    20,     0,    10,     0,     0,
       0,   180,   177,   178,   175,   176,    69,     0,   101,     0,
       0,     0,     0,     0,   106,   104,   105,   107,     0,   135,
     123,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   122,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   102,   135,   135,   130,
      24,     0,     0,     0,    50,    49,    23,    22,     0,    38,
       0,     0,     0,     0,     0,     0,    33,     0,     0,     0,
     146,     0,     0,     0,     0,     0,     0,     0,     0,    53,
       0,     0,    19,   113,     0,   115,     0,   117,     0,   119,
       0,     0,     0,     0,     0,   135,   128,   131,   149,   134,
       0,     0,     0,     0,     0,    26,     0,    40,    32,    51,
       0,    27,     0,     0,    36,    31,    39,    46,     0,    25,
       0,    12,     0,     0,     0,   109,     0,   110,     0,   111,
       0,     0,   108,     0,   149,   149,     0,   125,     0,   129,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   145,     0,     0,    16,    54,    18,   112,   114,   116,
       0,   118,     0,   126,   124,     0,     0,   136,     0,     0,
     170,   171,     0,     0,   150,   157,   160,     0,    42,    43,
      37,    41,    14,    29,     0,     0,     0,     0,    11,   121,
       0,   132,     0,   149,     0,     0,     0,   151,   155,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   147,
       0,    48,     0,     0,     0,   127,     0,   151,   137,     0,
       0,     0,     0,   156,   153,   154,   167,   168,   169,   165,
     166,     0,     0,    45,   120,     0,   159,     0,     0,     0,
     151,     0,     0,   152,     0,     0,     0,     0,     0,   148,
       0,   133,   151,     0,     0,     0,   141,   136,     0,   161,
     163,   162,   164,     0,   158,     0,   144,     0,     0,     0,
      34,     0,     0,   138,     0,     0,     0,     0,     0,     0,
       0,     0,   139,   140,   142,   143
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -470,  -470,  -470,   558,  -470,  -470,  -470,  -470,  -470,  -307,
    -470,   -49,  -470,  -470,  -470,  -470,  -470,  -470,  -470,  -470,
    -470,  -470,  -470,  -399,  -470,  -470,  -305,  -470,  -470,    95,
    -277,  -432,  -418,  -469,  -470,  -470,    -8,  -389,  -470,  -465,
    -470,  -393,  -445,  -460,  -470,   -53
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    47,    48,    49,   290,   177,   178,   380,   246,   350,
      50,   113,    51,   152,   229,   230,   274,   275,   276,   277,
     354,   356,   358,   360,   155,   316,   364,   278,   462,   279,
     319,   438,   439,   490,   369,   339,   340,   410,   411,   491,
     492,   444,   505,   445,   446,   447
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     107,   351,   430,   436,   464,    97,   111,   112,   281,   114,
     115,   116,   117,   118,   119,   432,   433,   508,   465,   125,
     362,   127,   509,    52,   506,   374,    98,    99,   138,   135,
     136,   137,   506,   139,   140,   141,   142,   143,   144,   466,
     366,   367,   148,    53,   153,   525,   363,   513,   489,   468,
     469,   120,   181,   182,   282,   283,    54,   535,   406,   284,
     506,   483,   285,   121,   488,   486,   520,   232,   507,   544,
     545,   286,   546,   547,   485,   534,   287,   288,   494,   495,
     528,   233,   235,   234,   289,   403,   420,   521,   409,   543,
     408,    55,   537,    56,   416,   437,   236,   -17,   156,   157,
     344,   338,   158,   159,   160,   345,   161,   162,    93,   163,
     403,   454,   164,   165,   166,    57,   167,   168,   169,   170,
     171,   172,   173,   174,   185,   186,    58,   175,   176,   539,
     262,   263,   264,   265,   103,   104,   440,   441,   542,   103,
     104,   440,   441,   392,   103,   104,   105,    59,   393,    60,
     106,   105,   471,   472,   442,   443,   105,   514,    61,   515,
     106,   183,   184,   185,   186,   493,   473,   474,   475,   476,
     477,   183,   184,   185,   186,   256,    62,   261,   257,   267,
       1,     2,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,   183,   184,   185,   186,   394,   395,   479,   328,   396,
     393,   329,   480,   183,   184,   185,   186,   315,   273,    42,
     183,   184,   185,   186,   419,   471,   472,    63,   187,    43,
      44,   269,   270,   271,   272,    64,   273,    45,   473,   474,
     475,   476,   477,   183,   184,   185,   186,   183,   184,   185,
     186,    46,    96,    65,    66,   216,   183,   184,   185,   186,
      67,   100,    68,   403,   231,   382,   516,   459,   517,    69,
     183,   184,   185,   186,   183,   184,   185,   186,    70,    94,
     261,   183,   184,   185,   186,    71,   393,   519,   403,    72,
     478,    73,   504,   183,   184,   185,   186,   397,   399,   402,
     398,   400,   403,   407,   434,   150,   408,   408,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    95,   102,   108,
     109,   110,   122,   123,   124,   126,   128,   129,   130,   131,
     132,   133,   134,   145,   146,   147,   455,   149,   228,   151,
     154,   199,   310,   317,   311,   421,     0,     0,     0,   259,
     260,     0,     0,     0,     0,   179,     0,     0,   180,     0,
     470,   188,   189,   190,   191,     0,   192,   193,   194,   195,
     196,   197,   198,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   217,
     496,   497,   498,   499,   500,   218,   219,   502,   220,   221,
     222,   223,   224,   225,   226,   227,   237,   238,   239,   268,
     241,   242,   240,   244,   245,   243,   247,   248,   249,   250,
     280,   291,   253,   251,   252,   292,   254,   255,   266,   293,
     294,   529,   530,   531,   532,   258,   295,   296,   297,   298,
     300,   299,   302,   301,   303,   304,   307,   308,   305,   306,
     312,   309,   314,   313,   361,     0,   318,   330,   368,     0,
       0,   320,     0,   321,   322,   323,   404,     0,     0,   324,
       0,   325,   326,   327,   331,   333,   334,   332,   335,   337,
     338,   349,   336,   341,   342,   343,   346,   347,   353,   355,
     352,   357,   359,   365,   348,   370,   371,   372,   375,   373,
     362,   376,   377,   378,   379,   381,   388,   390,   512,     0,
       0,   383,   384,   405,     0,   385,     0,   401,   425,   457,
     386,   387,   389,   391,   427,   428,   412,   413,   414,   415,
     417,   418,   423,   429,   431,   424,   422,   426,   435,   448,
     449,   450,   461,   463,   451,   452,   453,   456,   458,   437,
    -138,   511,   518,   460,   481,   523,  -137,   482,   527,   467,
     520,   484,   543,   503,   487,   501,   526,   510,   548,   533,
     522,   549,   524,   550,   551,   536,   101,   540,     0,   538,
       0,   552,   553,   554,   555,   541
};

static const yytype_int16 yycheck[] =
{
      53,   308,   401,     4,   436,    94,    92,    93,     3,    58,
      59,    60,    61,    62,    63,   404,   405,   486,   436,    68,
      96,    70,   487,   115,   484,   330,   115,   116,    81,    78,
      79,    80,   492,    82,    83,    84,    85,    86,    87,   438,
     317,   318,    91,   115,    97,   510,   122,   492,   466,   442,
     443,    95,   105,   106,    49,    50,   115,   522,   363,    54,
     520,   460,    57,   107,    96,   464,   100,   100,   486,   538,
     539,    66,   541,   542,   463,   520,    71,    72,   471,   472,
     512,   114,   100,   116,    79,   117,    96,   121,   365,    96,
     117,   115,   524,   115,   121,    96,   114,    46,    47,    48,
     112,   111,    51,    52,    53,   117,    55,    56,   114,    58,
     117,   418,    61,    62,    63,   115,    65,    66,    67,    68,
      69,    70,    71,    72,   108,   109,   115,    76,    77,   528,
     183,   184,   185,   186,    95,    96,    92,    93,   537,    95,
      96,    92,    93,   112,    95,    96,   107,   115,   117,   115,
     111,   107,    99,   100,   110,   111,   107,   102,   115,   104,
     111,   106,   107,   108,   109,   112,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   111,   115,   112,   114,   228,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,   106,   107,   108,   109,   112,   114,   112,   111,   117,
     117,   114,   117,   106,   107,   108,   109,    87,    88,    64,
     106,   107,   108,   109,   117,    99,   100,   115,   114,    74,
      75,    83,    84,    85,    86,   115,    88,    82,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   106,   107,   108,
     109,    96,    96,   115,   115,   114,   106,   107,   108,   109,
     115,     0,   115,   117,   114,   338,   102,   121,   104,   115,
     106,   107,   108,   109,   106,   107,   108,   109,   115,    98,
     112,   106,   107,   108,   109,   115,   117,   112,   117,   115,
     121,   115,   121,   106,   107,   108,   109,   114,   114,   114,
     117,   117,   117,   114,   114,   114,   117,   117,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   111,    95,    95,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
      95,    95,    95,    95,    95,    95,   419,    95,   117,    96,
      96,    95,   122,   278,   122,   383,    -1,    -1,    -1,    73,
      46,    -1,    -1,    -1,    -1,   114,    -1,    -1,   113,    -1,
     443,   114,   114,   114,   114,    -1,   114,   114,   114,   114,
     114,   114,   114,   114,   114,   114,   114,   114,   114,   114,
     114,   114,   114,   114,   114,   114,   114,   114,   114,   114,
     473,   474,   475,   476,   477,   114,   114,   480,   114,   114,
     114,   114,   114,   114,   114,   114,   111,   111,   111,    91,
     111,   111,   114,   111,   111,   114,   111,   111,   111,   111,
      96,    96,   111,   114,   114,    96,   114,   114,   114,    96,
      96,   514,   515,   516,   517,   118,    98,    96,    98,    96,
      96,   111,    96,    98,    96,    96,   111,   111,    98,    98,
     122,   112,    96,   122,   122,    -1,   114,   120,    90,    -1,
      -1,   114,    -1,   111,   111,   111,    89,    -1,    -1,   114,
      -1,   114,   114,   114,   112,   112,   112,   117,   112,   112,
     111,    96,   117,   112,   112,   112,   112,   117,    96,    96,
     114,    96,    96,   114,   119,    96,    96,    95,   114,    96,
      96,    96,   114,   114,   114,   114,    96,    95,   121,    -1,
      -1,   117,   114,   100,    -1,   114,    -1,   120,    96,    95,
     114,   114,   114,   114,    96,    96,   112,   112,   112,   112,
     112,   120,   112,    96,    96,   114,   117,   114,    96,   114,
     114,   114,    96,   100,   114,   114,   114,   112,   114,    96,
      96,    96,    96,   120,   114,    96,   120,   112,    96,   120,
     100,   120,    96,   114,   120,   117,   114,   120,    96,   112,
     120,    96,   121,    96,    96,   114,    48,   114,    -1,   121,
      -1,   114,   114,   114,   114,   121
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    64,    74,    75,    82,    96,   124,   125,   126,
     133,   135,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   114,    98,   111,    96,    94,   115,   116,
       0,   126,    95,    95,    96,   107,   111,   168,    95,    95,
      95,    92,    93,   134,   134,   134,   134,   134,   134,   134,
      95,   107,    95,    95,    95,   134,    95,   134,    95,    95,
      95,    95,    95,    95,    95,   134,   134,   134,   168,   134,
     134,   134,   134,   134,   134,    95,    95,    95,   134,    95,
     114,    96,   136,   168,    96,   147,    47,    48,    51,    52,
      53,    55,    56,    58,    61,    62,    63,    65,    66,    67,
      68,    69,    70,    71,    72,    76,    77,   128,   129,   114,
     113,   168,   168,   106,   107,   108,   109,   114,   114,   114,
     114,   114,   114,   114,   114,   114,   114,   114,   114,    95,
     114,   114,   114,   114,   114,   114,   114,   114,   114,   114,
     114,   114,   114,   114,   114,   114,   114,   114,   114,   114,
     114,   114,   114,   114,   114,   114,   114,   114,   117,   137,
     138,   114,   100,   114,   116,   100,   114,   111,   111,   111,
     114,   111,   111,   114,   111,   111,   131,   111,   111,   111,
     111,   114,   114,   111,   114,   114,   111,   114,   118,    73,
      46,   112,   168,   168,   168,   168,   114,   134,    91,    83,
      84,    85,    86,    88,   139,   140,   141,   142,   150,   152,
      96,     3,    49,    50,    54,    57,    66,    71,    72,    79,
     127,    96,    96,    96,    96,    98,    96,    98,    96,   111,
      96,    98,    96,    96,    96,    98,    98,   111,   111,   112,
     122,   122,   122,   122,    96,    87,   148,   152,   114,   153,
     114,   111,   111,   111,   114,   114,   114,   114,   111,   114,
     120,   112,   117,   112,   112,   112,   117,   112,   111,   158,
     159,   112,   112,   112,   112,   117,   112,   117,   119,    96,
     132,   132,   114,    96,   143,    96,   144,    96,   145,    96,
     146,   122,    96,   122,   149,   114,   153,   153,    90,   157,
      96,    96,    95,    96,   149,   114,    96,   114,   114,   114,
     130,   114,   168,   117,   114,   114,   114,   114,    96,   114,
      95,   114,   112,   117,   112,   114,   117,   114,   117,   114,
     117,   120,   114,   117,    89,   100,   149,   114,   117,   153,
     160,   161,   112,   112,   112,   112,   121,   112,   120,   117,
      96,   159,   117,   112,   114,    96,   114,    96,    96,    96,
     146,    96,   160,   160,   114,    96,     4,    96,   154,   155,
      92,    93,   110,   111,   164,   166,   167,   168,   114,   114,
     114,   114,   114,   114,   132,   168,   112,    95,   114,   121,
     120,    96,   151,   100,   154,   155,   146,   120,   164,   164,
     168,    99,   100,   101,   102,   103,   104,   105,   121,   112,
     117,   114,   112,   146,   120,   160,   146,   120,    96,   155,
     156,   162,   163,   112,   164,   164,   168,   168,   168,   168,
     168,   117,   168,   114,   121,   165,   166,   155,   156,   162,
     120,    96,   121,   165,   102,   104,   102,   104,    96,   112,
     100,   121,   120,    96,   121,   162,   114,    96,   154,   168,
     168,   168,   168,   112,   165,   162,   114,   154,   121,   146,
     114,   121,   146,    96,   156,   156,   156,   156,    96,    96,
      96,    96,   114,   114,   114,   114
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   123,   124,   125,   125,   126,   126,   126,   126,   126,
     126,   126,   126,   127,   126,   128,   126,   129,   126,   126,
     126,   126,   126,   126,   126,   126,   126,   126,   126,   126,
     126,   126,   126,   130,   126,   126,   126,   126,   126,   126,
     126,   126,   126,   126,   126,   126,   126,   131,   126,   126,
     126,   126,   126,   132,   132,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   134,   134,
     136,   135,   137,   138,   138,   138,   138,   138,   139,   140,
     141,   142,   143,   143,   144,   144,   145,   145,   146,   146,
     146,   146,   147,   147,   148,   148,   149,   149,   150,   150,
     150,   150,   151,   152,   153,   153,   154,   155,   156,   157,
     157,   157,   157,   157,   157,   158,   158,   159,   159,   161,
     160,   163,   162,   164,   164,   164,   164,   164,   165,   165,
     166,   166,   166,   166,   166,   167,   167,   167,   167,   167,
     167,   167,   168,   168,   168,   168,   168,   168,   168,   168,
     168
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     3,     2,     4,
       4,     9,     7,     0,     9,     0,     8,     0,     8,     7,
       4,     4,     6,     6,     6,     7,     7,     7,     4,     9,
       4,     7,     7,     0,    14,     4,     7,     9,     6,     7,
       7,     9,     9,     9,     4,    11,     7,     0,    10,     6,
       6,     7,     4,     1,     3,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     5,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     1,     1,
       0,     5,     3,     0,     2,     2,     2,     2,     4,     4,
       4,     4,     3,     1,     3,     1,     3,     1,     3,     1,
       6,     4,     3,     3,     4,     3,     3,     5,     3,     4,
       2,     3,     1,     9,     2,     0,     1,     1,     1,    11,
      11,     7,    12,    12,     8,     3,     1,     5,     7,     0,
       2,     0,     2,     3,     3,     2,     3,     1,     3,     1,
       1,     5,     5,     5,     5,     3,     3,     3,     3,     3,
       1,     1,     1,     2,     1,     3,     3,     3,     3,     2,
       3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 7:
#line 289 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { cout << *((yyvsp[-1].mystring)) << endl; }
#line 1929 "parser.cc" /* yacc.c:1646  */
    break;

  case 8:
#line 291 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { cout << "Automata in memory:" << endl;
      for (const auto& p : paut_map) {
        cout << p.first << " ";
        cout << "(" << (p.second)->name << "):";
        p.second->print_size();
      }
      cout << endl << "Constants in memory:" << endl;
      for (const auto& p : rae_map) {
        cout << p.first << " := " << p.second << endl;
      }
      cout << endl << "Symbolic states in memory:" << endl;
      for (const auto& p : ss_map) {
        cout << p.first << " : " << p.second.first.size() << " locs, "
             << p.second.first.get_memory() << " bytes" << endl;
      }
      cout << endl;
    }
#line 1951 "parser.cc" /* yacc.c:1646  */
    break;

  case 9:
#line 313 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-3].mystring));
      const auto& id = *((yyvsp[-1].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        ss_map[dst] = ss_map[id];
      } else if (paut_map.find(id) != paut_map.end()) {
        paut = new automaton(*paut_map[id]);
        paut->name = dst;
        paut_map[dst].reset(paut);
      } else
        yyerror("Identifier " + id + " not found.");
      delete (yyvsp[-3].mystring);
      delete (yyvsp[-1].mystring);
    }
#line 1970 "parser.cc" /* yacc.c:1646  */
    break;

  case 10:
#line 328 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-3].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        if (ss_map[id].second != nullptr) {
          cout << id << " = "
               << ss_map[id].second->name << ".";
          if (ss_map[id].first.empty())
            cout << "{};" << endl;
          else {
            cout << "{" << endl;
            ss_map[id].first.print_phaver(cout);
            cout << endl << "};" << endl;
          }
        } else
          ss_map[id].first.print_phaver(cout);
      } else if (paut_map.find(id) != paut_map.end()) {
        paut_map[id]->print();
      } else
        yyerror("Identifier " + id + " not found.");
      delete (yyvsp[-3].mystring);
    }
#line 1996 "parser.cc" /* yacc.c:1646  */
    break;

  case 11:
#line 350 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-8].mystring));
      const auto& fname = *((yyvsp[-4].mystring));
      int format = atoi_consume((yyvsp[-2].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        file_out.open(fname);
        file_out.precision(FP_PRECISION);
        if (format == 1) // constraint form
          ss_map[id].first.print_con_fp_raw(file_out);
        else if (format == 2) // generator form
          ss_map[id].first.print_gen_fp_raw(file_out);
        else if (format == 3) // debug form
          ss_map[id].first.print();
        else if (format == 4) // debug form
          ss_map[id].first.print(ss_map[id].second->get_loc_names());
        else {
          file_out << id << " = "
                   << ss_map[id].second->name << ".";
          if (ss_map[id].first.empty())
            file_out << "{};" << endl;
          else {
            file_out << "{" << endl;
            ss_map[id].first.print_phaver(file_out);
            file_out << endl << "};";
          }
        }
        file_out.close();
      } else if (paut_map.find(id) != paut_map.end()) {
        file_out.open(fname);
        if (format == 1) // dot form (graphviz)
          paut_map[id]->print_dot(file_out);
        else
          paut_map[id]->print_phaver(file_out);
        file_out.close();
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-8].mystring);
      delete (yyvsp[-4].mystring);
    }
#line 2040 "parser.cc" /* yacc.c:1646  */
    break;

  case 12:
#line 390 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-6].mystring));
      const auto& fname = *((yyvsp[-2].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        file_out.open(fname);
        file_out.precision(FP_PRECISION);
        clock_val_set temp_cvs = ss_map[id].first.union_over_locations();
        temp_cvs.print_con_fp_raw(file_out);
        file_out.close();
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2059 "parser.cc" /* yacc.c:1646  */
    break;

  case 13:
#line 408 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-1].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut = paut_map[id].get();
      else
        yyerror("Automaton '" + id + "' not found.");
    }
#line 2071 "parser.cc" /* yacc.c:1646  */
    break;

  case 14:
#line 416 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-8].mystring));
      const auto& states = *((yyvsp[-2].symb_state));
      ss_map[dst] = make_pair(std::move(states), paut);
      delete (yyvsp[-8].mystring);
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].symb_state);
    }
#line 2084 "parser.cc" /* yacc.c:1646  */
    break;

  case 15:
#line 425 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-1].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        psymb_state = &ss_map[id].first;
        paut = ss_map[id].second;
      } else {
        yyerror("Unknown state identifier '" + id +"'.");
        psymb_state = nullptr;
      }
    }
#line 2099 "parser.cc" /* yacc.c:1646  */
    break;

  case 16:
#line 436 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-7].mystring));
      if ((yyvsp[-2].vrs) != nullptr) {
        if (ss_map.find(id) != ss_map.end())
          ss_map[id].first.remove_space_dimensions(*(yyvsp[-2].vrs));
        else
          yyerror("Unknown identifier '" + id +"'.");
      }
      psymb_state = nullptr;
      delete (yyvsp[-7].mystring);
      delete (yyvsp[-2].vrs);
    }
#line 2116 "parser.cc" /* yacc.c:1646  */
    break;

  case 17:
#line 449 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-1].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        psymb_state = &ss_map[id].first;
        paut = ss_map[id].second;
      } else {
        psymb_state = nullptr;
        paut = nullptr;
        if (paut_map.find(id) != paut_map.end())
          paut = paut_map[id].get();
        else
          yyerror("Unknown identifier '" + id +"'.");
      }
    }
#line 2135 "parser.cc" /* yacc.c:1646  */
    break;

  case 18:
#line 464 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-7].mystring));
      if ((yyvsp[-2].vrs) != nullptr) {
        if (psymb_state != nullptr)
          ss_map[id].first.project_to_vars(*(yyvsp[-2].vrs));
        else if (paut != nullptr)
          paut->project_to_vars(*(yyvsp[-2].vrs));
        else yyerror("Unknown identifier '" + id +"'.");
      }
      psymb_state = nullptr;
      paut = nullptr;
      delete (yyvsp[-7].mystring);
      delete (yyvsp[-2].vrs);
    }
#line 2154 "parser.cc" /* yacc.c:1646  */
    break;

  case 19:
#line 479 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-4].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        auto sstates = ss_map[id].first;
        const var_ref_set& vrs = ss_map[id].second->parameters;
        auto dim = ss_map[id].second->dim;
        sstates.remove_space_dimensions(vrs.range_complement(0, dim));
        clock_val_set tmp;
        if ((yyvsp[-2].mybool)) {
          cout << "Parameters in any of the locations:" << endl;
          tmp = sstates.union_over_locations();
        } else {
          cout << "Parameters common to all locations:" << endl;
          tmp = sstates.intersection_over_locations();
        }
        tmp.print();
      }
      else
        yyerror("Identifier " + id + " not found.");
      delete (yyvsp[-4].mystring);
    }
#line 2180 "parser.cc" /* yacc.c:1646  */
    break;

  case 20:
#line 501 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-3].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        const auto& mycvs = ss_map[id].first.union_over_locations();
        mycvs.print(ss_map[id].first.var_names);
        mycvs.print_gen_fp_raw(cout);
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-3].mystring);
    }
#line 2195 "parser.cc" /* yacc.c:1646  */
    break;

  case 21:
#line 512 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-3].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        const auto& mycvs = ss_map[id].first.intersection_over_locations();
        mycvs.print(ss_map[id].first.var_names);
        mycvs.print_gen_fp_raw(cout);
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-3].mystring);
    }
#line 2210 "parser.cc" /* yacc.c:1646  */
    break;

  case 22:
#line 523 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-5].mystring));
      const auto& id = *((yyvsp[-3].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        auto mycvs = ss_map[id].first.union_over_locations();
        symb_states_type ss(ss_map[id].first.var_names);
        ss.add("$", std::move(mycvs));
        ss_map[dst] = make_pair(std::move(ss), ss_map[id].second);
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-5].mystring);
      delete (yyvsp[-3].mystring);
    }
#line 2228 "parser.cc" /* yacc.c:1646  */
    break;

  case 23:
#line 537 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-5].mystring));
      const auto& id = *((yyvsp[-3].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        auto mycvs = ss_map[id].first.intersection_over_locations();
        symb_states_type ss(ss_map[id].first.var_names);
        ss.add("$", std::move(mycvs));
        ss_map[dst] = make_pair(std::move(ss), ss_map[id].second);
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-5].mystring);
      delete (yyvsp[-3].mystring);
    }
#line 2246 "parser.cc" /* yacc.c:1646  */
    break;

  case 24:
#line 551 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-5].mystring));
      const auto& id = *((yyvsp[-3].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        auto sstates = ss_map[id].first.merge_splitted();
        ss_map[dst] = make_pair(std::move(sstates), nullptr);
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-5].mystring);
      delete (yyvsp[-3].mystring);
    }
#line 2262 "parser.cc" /* yacc.c:1646  */
    break;

  case 25:
#line 563 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id1 = *((yyvsp[-6].mystring));
      const auto& id2 = *((yyvsp[-2].mystring));
      if (ss_map.find(id1) != ss_map.end()) {
        if (ss_map.find(id2) != ss_map.end())
          ss_map[id1].first.intersection_assign(ss_map[id2].first);
        else
          yyerror("Unknown identifier '" + id2 +"'.");
      } else
        yyerror("Unknown identifier '" + id1 +"'.");
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2280 "parser.cc" /* yacc.c:1646  */
    break;

  case 26:
#line 577 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id1 = *((yyvsp[-6].mystring));
      const auto& id2 = *((yyvsp[-2].mystring));
      if (ss_map.find(id1) != ss_map.end()) {
        if (ss_map.find(id2) != ss_map.end())
          ss_map[id1].first.difference_assign(ss_map[id2].first);
        else
          yyerror("Unknown identifier '" + id2 +"'.");
      } else
        yyerror("Unknown identifier '" + id1 +"'.");
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2298 "parser.cc" /* yacc.c:1646  */
    break;

  case 27:
#line 591 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id1 = *((yyvsp[-6].mystring));
      const auto& id2 = *((yyvsp[-2].mystring));
      if (ss_map.find(id1) != ss_map.end()) {
        if (ss_map.find(id2) != ss_map.end()) {
          if (ss_map[id1].first.contains(ss_map[id2].first))
            cout << id1 << " contains " << id2;
          else
            cout << id1 << " does not contain " << id2;
        } else
          yyerror("Unknown identifier '" + id2 +"'.");
      } else
        yyerror("Unknown identifier '" + id1 +"'.");
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2319 "parser.cc" /* yacc.c:1646  */
    break;

  case 28:
#line 608 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-3].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        if (ss_map[id].first.is_empty())
          cout << "empty";
        else
          cout << "not empty";
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-3].mystring);
    }
#line 2335 "parser.cc" /* yacc.c:1646  */
    break;

  case 29:
#line 620 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-8].mystring));
      const auto& name1 = *((yyvsp[-4].mystring));
      const auto& name2 = *((yyvsp[-2].mystring));
      if (ss_map.find(id) != ss_map.end()) {
        ss_map[id].first.rename_variable(name1, name2);
        // remove the reference to any automaton because now it's changed
        ss_map[id].second = nullptr;
      } else
        yyerror("Unknown identifier '" + id +"'.");
      delete (yyvsp[-8].mystring);
      delete (yyvsp[-4].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2354 "parser.cc" /* yacc.c:1646  */
    break;

  case 30:
#line 638 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& comp_name = *((yyvsp[-3].mystring));
      const auto& aut_names = *((yyvsp[-1].ident_list));
      assert(!aut_names.empty());
      bool first = true;
      for (const auto& aut_name : aut_names) {
        const auto iter = paut_map.find(aut_name);
        if (iter == paut_map.end())
          yyerror("Automaton '" + aut_name + "' not found.");
        assert(iter->second != nullptr);
        const automaton& aut = *(iter->second);
        if (first) {
          paut = new automaton(aut);
          first = false;
          continue;
        }
        automaton* pcomp = new automaton();
        compose_discrete(*pcomp, *paut, aut);
        std::swap(paut, pcomp);
        delete pcomp;
      }
      paut->name = comp_name;
      paut_map[comp_name].reset(paut);
      delete (yyvsp[-3].mystring);
      delete (yyvsp[-1].ident_list);
    }
#line 2385 "parser.cc" /* yacc.c:1646  */
    break;

  case 31:
#line 665 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-6].mystring));
      const auto& fname = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end()) {
        file_out.open(fname);
        file_out.precision(FP_PRECISION);
        paut_map[id]->print_inv_fp_raw(file_out);
        file_out.close();
      } else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2403 "parser.cc" /* yacc.c:1646  */
    break;

  case 32:
#line 679 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-6].mystring));
      const auto& fname = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end()) {
        file_out.open(fname);
        file_out.precision(FP_PRECISION);
        paut_map[id]->print_surface_fp_raw(file_out);
        file_out.close();
      }	else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2421 "parser.cc" /* yacc.c:1646  */
    break;

  case 33:
#line 693 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-5].mystring));
      psymb_state = nullptr;
      if (paut_map.find(id) != paut_map.end())
        paut = paut_map[id].get();
      else
        yyerror("Automaton '" + id + "' not found.");
    }
#line 2434 "parser.cc" /* yacc.c:1646  */
    break;

  case 34:
#line 702 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-13].mystring));
      const auto& fname = *((yyvsp[-9].mystring));
      const auto& var_list = *((yyvsp[-5].vrs));
      const auto& id2 = *((yyvsp[-2].mystring));
      psymb_state = nullptr;
      if (paut_map.find(id) != paut_map.end()) {
        paut = paut_map[id].get();
        file_out.open(fname);
        file_out.precision(FP_PRECISION);
        if (ss_map.find(id2) != ss_map.end())
          paut->print_graph(file_out, var_list, ss_map[id2].first);
        else
          yyerror("Unknown identifier '" + id2 + "'.");
        file_out.close();
      } else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-13].mystring);
      delete (yyvsp[-9].mystring);
      delete (yyvsp[-5].vrs);
      delete (yyvsp[-2].mystring);
    }
#line 2461 "parser.cc" /* yacc.c:1646  */
    break;

  case 35:
#line 725 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-3].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut_map[id]->reverse();
      else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-3].mystring);
    }
#line 2474 "parser.cc" /* yacc.c:1646  */
    break;

  case 36:
#line 734 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-6].mystring));
      const auto& lab = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut_map[id]->add_label(lab);
      else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2489 "parser.cc" /* yacc.c:1646  */
    break;

  case 37:
#line 745 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-8].mystring));
      const auto& id = *((yyvsp[-6].mystring));
      int delta = atoi_consume((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end())
        ss_map[dst] = make_pair(paut_map[id]->get_reach_set_forwarditer(delta),
                                paut_map[id].get());
      else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-8].mystring);
      delete (yyvsp[-6].mystring);
    }
#line 2506 "parser.cc" /* yacc.c:1646  */
    break;

  case 38:
#line 758 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-5].mystring));
      const auto& id = *((yyvsp[-3].mystring));
      if (paut_map.find(id) != paut_map.end())
        ss_map[dst] = make_pair(paut_map[id]->get_reach_set(),
                                paut_map[id].get());
      else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-5].mystring);
      delete (yyvsp[-3].mystring);
    }
#line 2522 "parser.cc" /* yacc.c:1646  */
    break;

  case 39:
#line 770 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-6].mystring));
      const auto& id_init = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut = paut_map[id].get();
      else {
        yyerror("Automaton '" + id + "' not found.");
        paut = nullptr;
      }
      if (paut != nullptr) {
        if (ss_map.find(id_init) != ss_map.end())
          paut->ini_states_assign(ss_map[id_init].first);
        else
          yyerror("Unknown identifier '" + id_init +"'.");
      }
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2545 "parser.cc" /* yacc.c:1646  */
    break;

  case 40:
#line 789 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-6].mystring));
      const auto& id_inv = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut = paut_map[id].get();
      else {
        yyerror("Automaton '" + id + "' not found.");
        paut = nullptr;
      }
      if (paut != nullptr) {
        if (ss_map.find(id_inv) != ss_map.end())
          paut->invariant_assign(ss_map[id_inv].first);
        else
          yyerror("Unknown identifier '" + id_inv +"'.");
      }
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2568 "parser.cc" /* yacc.c:1646  */
    break;

  case 41:
#line 808 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-8].mystring));
      const auto& id = *((yyvsp[-6].mystring));
      const auto& id_ini = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut = paut_map[id].get();
      else {
        yyerror("Automaton '" + id + "' not found.");
        paut = nullptr;
      }
      if (paut != nullptr) {
        if (ss_map.find(id_ini) != ss_map.end()) {
          symb_states_type dummystates;
          bool dummybool;
          ss_map[dst] = make_pair(paut->get_reach_set(ss_map[id_ini].first,
                                                      dummystates, dummybool),
                                  paut);
        }
        else
          yyerror("Unknown identifier '" + id_ini +"'.");
      }
      delete (yyvsp[-8].mystring);
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2598 "parser.cc" /* yacc.c:1646  */
    break;

  case 42:
#line 834 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-8].mystring));
      const auto& id = *((yyvsp[-6].mystring));
      const auto& target = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut = paut_map[id].get();
      else {
        yyerror("Automaton '" + id + "' not found.");
        paut = nullptr;
      }
      if (paut != nullptr) {
        if (ss_map.find(target) != ss_map.end()) {
          symb_states_type sstates;
          if (paut->is_reachable(ss_map[target].first, sstates))
            cout << target << " is reachable." << endl;
          else
            cout << target << " not reachable." << endl;
          ss_map[dst] = make_pair(std::move(sstates), paut);
        }
        else
          yyerror("Unknown identifier '" + target +"'.");
      }
      delete (yyvsp[-8].mystring);
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2629 "parser.cc" /* yacc.c:1646  */
    break;

  case 43:
#line 861 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-8].mystring));
      const auto& id = *((yyvsp[-6].mystring));
      const auto& target = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut = paut_map[id].get();
      else {
        yyerror("Automaton '" + id + "' not found.");
        paut = nullptr;
      }
      if (paut != nullptr) {
        if (ss_map.find(target) != ss_map.end()) {
          symb_states_type sstates;
          if (paut->is_reachable_fb(ss_map[target].first, sstates))
            cout << target << " is reachable." << endl;
          else
            cout << target << " not reachable." << endl;
          ss_map[dst] = make_pair(std::move(sstates), paut);
        }
        else
          yyerror("Unknown identifier '" + target +"'.");
      }
      delete (yyvsp[-8].mystring);
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2660 "parser.cc" /* yacc.c:1646  */
    break;

  case 44:
#line 888 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-3].mystring));
      refine_loc_deriv(*paut_map[id]);
      delete (yyvsp[-3].mystring);
    }
#line 2670 "parser.cc" /* yacc.c:1646  */
    break;

  case 45:
#line 894 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-10].mystring));
      const auto& label = *((yyvsp[-6].mystring));
      const auto& method = *((yyvsp[-4].mystring));
      refinement_method ref_meth;
      if (method == "carth_center")
        ref_meth = carth_center;
      else if (method == "carth0_center")
        ref_meth = carth0_center;
      else if (method == "carth1_center")
        ref_meth = carth1_center;
      else if (method == "deriv_center")
        ref_meth = deriv_center;
      else if (method == "jacob_center")
        ref_meth = jacob_center;
      else if (method == "deriv_dcenter")
        ref_meth = deriv_dcenter;
      else if (method == "jacob_dcenter")
        ref_meth = jacob_dcenter;
      else {
        ref_meth = carth_center;
        yyerror("Unknown refinement method '" + method + "'.");
      }
      paut = paut_map[id].get();
      refine_locs(*paut, paut->get_label_ref(label),
                  ref_meth, atoi_consume((yyvsp[-2].mystring)));
      delete (yyvsp[-10].mystring);
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-4].mystring);
    }
#line 2705 "parser.cc" /* yacc.c:1646  */
    break;

  case 46:
#line 925 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-6].mystring));
      const auto& state = *((yyvsp[-2].mystring));
      paut = paut_map[id].get();
      refine_states(*paut, ss_map[state].first);
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2718 "parser.cc" /* yacc.c:1646  */
    break;

  case 47:
#line 934 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-2].mystring));
      paut = paut_map[id].get();
    }
#line 2727 "parser.cc" /* yacc.c:1646  */
    break;

  case 48:
#line 939 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& label = *((yyvsp[-2].mystring));
      REFINEMENT_CONS = *((yyvsp[-4].refinement_cons));
      REFINEMENT_LABEL = paut->get_label_ref(label);
      delete (yyvsp[-9].mystring);
      delete (yyvsp[-4].refinement_cons);
      delete (yyvsp[-2].mystring);
    }
#line 2740 "parser.cc" /* yacc.c:1646  */
    break;

  case 49:
#line 948 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-5].mystring));
      const auto& id = *((yyvsp[-3].mystring));
      if (paut_map.find(id) != paut_map.end())
        ss_map[dst] = make_pair(paut_map[id]->get_ini_states(),
                                paut_map[id].get());
      else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-5].mystring);
      delete (yyvsp[-3].mystring);
    }
#line 2756 "parser.cc" /* yacc.c:1646  */
    break;

  case 50:
#line 960 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& dst = *((yyvsp[-5].mystring));
      const auto& id = *((yyvsp[-3].mystring));
      if (paut_map.find(id) != paut_map.end())
        ss_map[dst] = make_pair(paut_map[id]->get_invariants(),
                                paut_map[id].get());
      else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-5].mystring);
      delete (yyvsp[-3].mystring);
    }
#line 2772 "parser.cc" /* yacc.c:1646  */
    break;

  case 51:
#line 973 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-6].mystring));
      const auto& state = *((yyvsp[-2].mystring));
      if (paut_map.find(id) != paut_map.end()) {
        if (ss_map.find(state) != ss_map.end())
          paut_map[id]->unlock_surface_locations(ss_map[state].first);
        else
          yyerror("Unknown identifier '" + state +"'.");
      } else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-6].mystring);
      delete (yyvsp[-2].mystring);
    }
#line 2790 "parser.cc" /* yacc.c:1646  */
    break;

  case 52:
#line 987 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-3].mystring));
      if (paut_map.find(id) != paut_map.end())
        paut_map[id]->unlock_locations();
      else
        yyerror("Automaton '" + id + "' not found.");
      delete (yyvsp[-3].mystring);
    }
#line 2803 "parser.cc" /* yacc.c:1646  */
    break;

  case 53:
#line 999 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      if (psymb_state != nullptr) {
        auto pvrs = new var_ref_set;
        if (psymb_state->var_names.contains_name(id)) {
          pvrs->insert(psymb_state->var_names.get_id(id));
          (yyval.vrs) = pvrs;
        } else {
          yyerror("Unknown state variable '" + id +"'.");
          delete pvrs;
          (yyval.vrs) = nullptr;
        }
      } else if (paut != nullptr) {
        auto pvrs = new var_ref_set;
        if (paut->var_id_map.contains_name(id)) {
          pvrs->insert(paut->var_id_map.get_id(id));
          (yyval.vrs) = pvrs;
        } else {
          yyerror("Unknown automaton variable '" + id +"'.");
          delete pvrs;
          (yyval.vrs) = nullptr;
        }
      } else
        yyerror("Don't know which set of states '"
                + id +"' refers to.");
      delete (yyvsp[0].mystring);
    }
#line 2835 "parser.cc" /* yacc.c:1646  */
    break;

  case 54:
#line 1027 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      if (psymb_state != nullptr) {
        if (psymb_state->var_names.contains_name(id)) {
          (yyvsp[-2].vrs)->insert(psymb_state->var_names.get_id(id));
          (yyval.vrs) = (yyvsp[-2].vrs);
        } else
          yyerror("Unknown state variable '" + id +"'.");
      }	else if (paut != nullptr) {
        if (paut->var_id_map.contains_name(id)) {
          (yyvsp[-2].vrs)->insert(paut->var_id_map.get_id(id));
          (yyval.vrs) = (yyvsp[-2].vrs);
        } else
          yyerror("Unknown automaton variable '" + id +"'.");
      } else
        yyerror("Don't know which set of states '"
                + id +"' refers to.");
      delete (yyvsp[0].mystring);
    }
#line 2859 "parser.cc" /* yacc.c:1646  */
    break;

  case 55:
#line 1050 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-3].mystring));
      const auto& rae = *((yyvsp[-1].rae));
      rae_map[id] = rae;
      delete (yyvsp[-3].mystring);
      delete (yyvsp[-1].rae);
    }
#line 2871 "parser.cc" /* yacc.c:1646  */
    break;

  case 56:
#line 1059 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { TIME_POST_ITER = atoi_consume((yyvsp[-1].mystring)); }
#line 2877 "parser.cc" /* yacc.c:1646  */
    break;

  case 57:
#line 1061 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      TIME_POST_CONE_LAMBDA= (yyvsp[-1].rae)->rat_inhomo_term();
      delete (yyvsp[-1].rae);
    }
#line 2886 "parser.cc" /* yacc.c:1646  */
    break;

  case 58:
#line 1066 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { TIME_POST_CONE_WIDEN_DELAY = atoi_consume((yyvsp[-1].mystring)); }
#line 2892 "parser.cc" /* yacc.c:1646  */
    break;

  case 59:
#line 1068 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { TIME_POST_CONE_WIDEN_PRECISION = atoi_consume((yyvsp[-1].mystring)); }
#line 2898 "parser.cc" /* yacc.c:1646  */
    break;

  case 60:
#line 1070 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { MEMORY_MODE = atoi_consume((yyvsp[-1].mystring)); }
#line 2904 "parser.cc" /* yacc.c:1646  */
    break;

  case 61:
#line 1073 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_CHEAP_CONTAINS=(yyvsp[-1].mybool); }
#line 2910 "parser.cc" /* yacc.c:1646  */
    break;

  case 62:
#line 1075 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_CHEAP_CONTAINS_USE_BBOX=(yyvsp[-1].mybool); }
#line 2916 "parser.cc" /* yacc.c:1646  */
    break;

  case 63:
#line 1077 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_USE_BBOX=(yyvsp[-1].mybool); }
#line 2922 "parser.cc" /* yacc.c:1646  */
    break;

  case 64:
#line 1079 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_USE_CONSTRAINT_HULL=(yyvsp[-1].mybool); }
#line 2928 "parser.cc" /* yacc.c:1646  */
    break;

  case 65:
#line 1081 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_USE_CONVEX_HULL=(yyvsp[-1].mybool); }
#line 2934 "parser.cc" /* yacc.c:1646  */
    break;

  case 66:
#line 1083 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_USE_TIME_ELAPSE = (yyvsp[-1].mybool); }
#line 2940 "parser.cc" /* yacc.c:1646  */
    break;

  case 67:
#line 1085 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_STOP_AT_FORB=(yyvsp[-1].mybool); }
#line 2946 "parser.cc" /* yacc.c:1646  */
    break;

  case 68:
#line 1087 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_MAX_ITER = atoi_consume((yyvsp[-1].mystring)); }
#line 2952 "parser.cc" /* yacc.c:1646  */
    break;

  case 69:
#line 1089 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_MAX_ITER = - atoi_consume((yyvsp[-1].mystring)); }
#line 2958 "parser.cc" /* yacc.c:1646  */
    break;

  case 70:
#line 1091 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_REPORT_INTERVAL = atoi_consume((yyvsp[-1].mystring)); }
#line 2964 "parser.cc" /* yacc.c:1646  */
    break;

  case 71:
#line 1093 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_USE_BBOX_ITER = atoi_consume((yyvsp[-1].mystring)); }
#line 2970 "parser.cc" /* yacc.c:1646  */
    break;

  case 72:
#line 1095 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_STOP_USE_CONVEX_HULL_ITER = atoi_consume((yyvsp[-1].mystring)); }
#line 2976 "parser.cc" /* yacc.c:1646  */
    break;

  case 73:
#line 1097 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_STOP_USE_CONVEX_HULL_SETTLE=(yyvsp[-1].mybool); }
#line 2982 "parser.cc" /* yacc.c:1646  */
    break;

  case 74:
#line 1099 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { LIMIT_CONSTRAINTS_METHOD=(yyvsp[-1].mybool); }
#line 2988 "parser.cc" /* yacc.c:1646  */
    break;

  case 75:
#line 1101 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_DERIVATIVE_METHOD = atoi_consume((yyvsp[-1].mystring)); }
#line 2994 "parser.cc" /* yacc.c:1646  */
    break;

  case 76:
#line 1103 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_PRIORITIZE_REACH_SPLIT=(yyvsp[-1].mybool); }
#line 3000 "parser.cc" /* yacc.c:1646  */
    break;

  case 77:
#line 1105 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_SMALLEST_FIRST=(yyvsp[-1].mybool); }
#line 3006 "parser.cc" /* yacc.c:1646  */
    break;

  case 78:
#line 1107 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_USE_FP=(yyvsp[-1].mybool); }
#line 3012 "parser.cc" /* yacc.c:1646  */
    break;

  case 79:
#line 1109 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      mpq_class q = (yyvsp[-1].rae)->rat_inhomo_term();
      REFINE_DERIV_MINANGLE = q.get_d();
      delete (yyvsp[-1].rae);
    }
#line 3022 "parser.cc" /* yacc.c:1646  */
    break;

  case 80:
#line 1115 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_PRIORITIZE_ANGLE=(yyvsp[-1].mybool); }
#line 3028 "parser.cc" /* yacc.c:1646  */
    break;

  case 81:
#line 1117 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_CONSTRAINT_LIMIT = atoi_consume((yyvsp[-1].mystring)); }
#line 3034 "parser.cc" /* yacc.c:1646  */
    break;

  case 82:
#line 1119 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { TP_CONSTRAINT_LIMIT = atoi_consume((yyvsp[-1].mystring)); }
#line 3040 "parser.cc" /* yacc.c:1646  */
    break;

  case 83:
#line 1121 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_CONSTRAINT_TRIGGER = atoi_consume((yyvsp[-1].mystring)); }
#line 3046 "parser.cc" /* yacc.c:1646  */
    break;

  case 84:
#line 1123 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_BITSIZE_TRIGGER = atoi_consume((yyvsp[-1].mystring)); }
#line 3052 "parser.cc" /* yacc.c:1646  */
    break;

  case 85:
#line 1125 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { CONSTRAINT_BITSIZE = atoi_consume((yyvsp[-1].mystring)); }
#line 3058 "parser.cc" /* yacc.c:1646  */
    break;

  case 86:
#line 1127 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      int sm = atoi_consume((yyvsp[-1].mystring));
      switch (sm) {
      case 0:
        SEARCH_METHOD = Search_Method::trx_based;
        break;
      case 1:
        SEARCH_METHOD = Search_Method::topsort;
        break;
      case 2:
        SEARCH_METHOD = Search_Method::topsort_reachable;
        break;
      default:
        yyerror("Expecting an integer in {0, 1, 2}");
        break;
      }
    }
#line 3080 "parser.cc" /* yacc.c:1646  */
    break;

  case 87:
#line 1145 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { SNAPSHOT_INTERVAL = atoi_consume((yyvsp[-1].mystring)); }
#line 3086 "parser.cc" /* yacc.c:1646  */
    break;

  case 88:
#line 1148 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_CHECK_TIME_RELEVANCE=(yyvsp[-1].mybool); }
#line 3092 "parser.cc" /* yacc.c:1646  */
    break;

  case 89:
#line 1150 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_CHECK_TIME_RELEVANCE_DURING=(yyvsp[-1].mybool); }
#line 3098 "parser.cc" /* yacc.c:1646  */
    break;

  case 90:
#line 1152 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_CHECK_TIME_RELEVANCE_FINAL=(yyvsp[-1].mybool); }
#line 3104 "parser.cc" /* yacc.c:1646  */
    break;

  case 91:
#line 1154 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_CHECK_TRANS_DIMS=(yyvsp[-1].mybool); }
#line 3110 "parser.cc" /* yacc.c:1646  */
    break;

  case 92:
#line 1156 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_PARTITION_INSIDE=(yyvsp[-1].mybool); }
#line 3116 "parser.cc" /* yacc.c:1646  */
    break;

  case 93:
#line 1158 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REACH_FB_REFINE_METHOD = atoi_consume((yyvsp[-1].mystring)); }
#line 3122 "parser.cc" /* yacc.c:1646  */
    break;

  case 94:
#line 1160 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_LOCATION_PLANE = atoi_consume((yyvsp[-1].mystring)); }
#line 3128 "parser.cc" /* yacc.c:1646  */
    break;

  case 95:
#line 1162 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_MAX_CHECKS = atoi_consume((yyvsp[-1].mystring)); }
#line 3134 "parser.cc" /* yacc.c:1646  */
    break;

  case 96:
#line 1164 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { REFINE_USE_NEW_SPLIT = (yyvsp[-1].mybool); }
#line 3140 "parser.cc" /* yacc.c:1646  */
    break;

  case 97:
#line 1166 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { pplite::Poly::set_minimize_filter_threshold(atoi_consume((yyvsp[-1].mystring))); }
#line 3146 "parser.cc" /* yacc.c:1646  */
    break;

  case 98:
#line 1170 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { (yyval.mybool) = true; }
#line 3152 "parser.cc" /* yacc.c:1646  */
    break;

  case 99:
#line 1171 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { (yyval.mybool) = false; }
#line 3158 "parser.cc" /* yacc.c:1646  */
    break;

  case 100:
#line 1176 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      if (paut_map.find(id) == paut_map.end()) {
        paut = new automaton(id);
        paut_map[id].reset(paut);
      } else
        yyerror("automaton " + id + " already defined");
      delete (yyvsp[0].mystring);
    }
#line 3172 "parser.cc" /* yacc.c:1646  */
    break;

  case 108:
#line 1202 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id_list = *((yyvsp[-1].ident_list));
      if (paut != nullptr) {
        for (const auto& lab : id_list)
          paut->add_label(lab);
      }
      else
        yyerror("synclabs: paut not defined");
      delete (yyvsp[-1].ident_list);
    }
#line 3187 "parser.cc" /* yacc.c:1646  */
    break;

  case 112:
#line 1228 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      paut->add_variable(id);
      delete (yyvsp[0].mystring);
    }
#line 3197 "parser.cc" /* yacc.c:1646  */
    break;

  case 113:
#line 1234 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      paut->add_variable(id);
      delete (yyvsp[0].mystring);
    }
#line 3207 "parser.cc" /* yacc.c:1646  */
    break;

  case 114:
#line 1243 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      paut->add_ext_variable(id);
      delete (yyvsp[0].mystring);
    }
#line 3217 "parser.cc" /* yacc.c:1646  */
    break;

  case 115:
#line 1249 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      paut->add_ext_variable(id);
      delete (yyvsp[0].mystring);
    }
#line 3227 "parser.cc" /* yacc.c:1646  */
    break;

  case 116:
#line 1258 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      paut->add_parameter(id);
      delete (yyvsp[0].mystring);
    }
#line 3237 "parser.cc" /* yacc.c:1646  */
    break;

  case 117:
#line 1264 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      paut->add_parameter(id);
      delete (yyvsp[0].mystring);
    }
#line 3247 "parser.cc" /* yacc.c:1646  */
    break;

  case 118:
#line 1273 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      (yyval.ident_list)->push_back(id);
      delete (yyvsp[0].mystring);
    }
#line 3257 "parser.cc" /* yacc.c:1646  */
    break;

  case 119:
#line 1279 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      (yyval.ident_list) = new std::list<string>;
      (yyval.ident_list)->push_back(id);
      delete (yyvsp[0].mystring);
    }
#line 3268 "parser.cc" /* yacc.c:1646  */
    break;

  case 120:
#line 1286 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& prefix = *((yyvsp[-3].mystring));
      auto& id_list = *((yyvsp[-1].ident_list));
      for (auto& s : id_list)
        s.insert(0, prefix);
      (yyval.ident_list)->splice((yyval.ident_list)->end(), id_list);
      delete (yyvsp[-3].mystring);
      delete (yyvsp[-1].ident_list);
    }
#line 3282 "parser.cc" /* yacc.c:1646  */
    break;

  case 121:
#line 1296 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& prefix = *((yyvsp[-3].mystring));
      auto& id_list = *((yyvsp[-1].ident_list));
      for (auto& s : id_list)
        s.insert(0, prefix);
      (yyval.ident_list) = (yyvsp[-1].ident_list);
      delete (yyvsp[-3].mystring);
    }
#line 3295 "parser.cc" /* yacc.c:1646  */
    break;

  case 122:
#line 1308 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      (yyval.ident_list)->push_back(id);
      delete (yyvsp[0].mystring);
    }
#line 3305 "parser.cc" /* yacc.c:1646  */
    break;

  case 123:
#line 1314 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id1 = *((yyvsp[-2].mystring));
      const auto& id2 = *((yyvsp[0].mystring));
      (yyval.ident_list) = new std::list<string>;
      (yyval.ident_list)->push_back(id1);
      (yyval.ident_list)->push_back(id2);
      delete (yyvsp[-2].mystring);
      delete (yyvsp[0].mystring);
    }
#line 3319 "parser.cc" /* yacc.c:1646  */
    break;

  case 124:
#line 1327 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      paut->ini_states_assign(*(yyvsp[-1].symb_state));
      delete (yyvsp[-1].symb_state);
    }
#line 3328 "parser.cc" /* yacc.c:1646  */
    break;

  case 125:
#line 1332 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      paut->ini_states_assign(*(yyvsp[-1].symb_state));
      delete (yyvsp[-1].symb_state);
    }
#line 3337 "parser.cc" /* yacc.c:1646  */
    break;

  case 126:
#line 1340 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& loc = *((yyvsp[-2].mystring));
      auto& state = *((yyvsp[0].cvs));
      if (paut != nullptr) {
        psymb_state = new symb_states_type(paut->get_var_names());
        psymb_state->add(loc, std::move(state));
        (yyval.symb_state) = psymb_state;
      }	else
        yyerror("Don't know which automaton to attribute states to.");
      delete (yyvsp[-2].mystring);
      delete (yyvsp[0].cvs);
    }
#line 3354 "parser.cc" /* yacc.c:1646  */
    break;

  case 127:
#line 1353 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& loc = *((yyvsp[-2].mystring));
      auto& state = *((yyvsp[0].cvs));
      if (paut != nullptr) {
        psymb_state->add(loc, std::move(state));
        (yyval.symb_state) = psymb_state;
      }
      else
        yyerror("Don't know which automaton to attribute states to.");
      delete (yyvsp[-2].mystring);
      delete (yyvsp[0].cvs);
    }
#line 3371 "parser.cc" /* yacc.c:1646  */
    break;

  case 132:
#line 1375 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { check_ident_consume((yyvsp[0].mystring), "wait"); }
#line 3377 "parser.cc" /* yacc.c:1646  */
    break;

  case 133:
#line 1379 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-7].mystring));
      const auto& inv = *((yyvsp[-4].cvs));
      auto& cpost = *((yyvsp[-1].con_list));
      swap_space_dims(cpost, 0, paut->dim, paut->dim);
      paut->add_location(std::move(inv), id, std::move(cpost));
      // will serve as the source location for the coming transitions
      current_loc_name = id;
      delete (yyvsp[-7].mystring);
      delete (yyvsp[-4].cvs);
      delete (yyvsp[-1].con_list);
    }
#line 3394 "parser.cc" /* yacc.c:1646  */
    break;

  case 136:
#line 1399 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { check_ident_consume((yyvsp[0].mystring), "sync"); }
#line 3400 "parser.cc" /* yacc.c:1646  */
    break;

  case 137:
#line 1401 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { check_ident_consume((yyvsp[0].mystring), "do"); }
#line 3406 "parser.cc" /* yacc.c:1646  */
    break;

  case 138:
#line 1403 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { check_ident_consume((yyvsp[0].mystring), "goto"); }
#line 3412 "parser.cc" /* yacc.c:1646  */
    break;

  case 139:
#line 1409 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& guard = *((yyvsp[-9].cvs));
      const auto& id_list = *((yyvsp[-7].ident_list));
      const auto& dpost = *((yyvsp[-4].con_list));
      const auto& target = *((yyvsp[-1].mystring));
      check_dpost(paut->dim, dpost, paut->variables);
      for (const auto& id : id_list)
        paut->add_transition(current_loc_name, id, target,
                             guard, dpost);
      delete (yyvsp[-9].cvs);
      delete (yyvsp[-7].ident_list);
      delete (yyvsp[-4].con_list);
      delete (yyvsp[-1].mystring);
    }
#line 3431 "parser.cc" /* yacc.c:1646  */
    break;

  case 140:
#line 1424 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& guard = *((yyvsp[-9].cvs));
      const auto& dpost = *((yyvsp[-6].con_list));
      const auto& id_list = *((yyvsp[-3].ident_list));
      const auto& target = *((yyvsp[-1].mystring));
      check_dpost(paut->dim, dpost, paut->variables);
      for (const auto& id : id_list)
        paut->add_transition(current_loc_name, id, target,
                             guard, dpost);
      delete (yyvsp[-9].cvs);
      delete (yyvsp[-6].con_list);
      delete (yyvsp[-3].ident_list);
      delete (yyvsp[-1].mystring);
    }
#line 3450 "parser.cc" /* yacc.c:1646  */
    break;

  case 141:
#line 1439 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& guard = *((yyvsp[-5].cvs));
      const auto& id_list = *((yyvsp[-3].ident_list));
      const auto& target = *((yyvsp[-1].mystring));
      // controlled variables should remain constant
      Cons dpost = identity_dpost(paut->dim, paut->variables);
      for (const auto& id : id_list)
        paut->add_transition(current_loc_name, id, target,
                             guard, dpost);
      delete (yyvsp[-5].cvs);
      delete (yyvsp[-3].ident_list);
      delete (yyvsp[-1].mystring);
    }
#line 3468 "parser.cc" /* yacc.c:1646  */
    break;

  case 142:
#line 1454 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& guard = *((yyvsp[-10].cvs));
      const auto& id_list = *((yyvsp[-7].ident_list));
      const auto& dpost = *((yyvsp[-4].con_list));
      const auto& target = *((yyvsp[-1].mystring));
      check_dpost(paut->dim, dpost, paut->variables);
      for (const auto& id : id_list)
        paut->add_transition(current_loc_name, id, target,
                             guard, dpost, Urgency::urgent);
      delete (yyvsp[-10].cvs);
      delete (yyvsp[-7].ident_list);
      delete (yyvsp[-4].con_list);
      delete (yyvsp[-1].mystring);
    }
#line 3487 "parser.cc" /* yacc.c:1646  */
    break;

  case 143:
#line 1470 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& guard = *((yyvsp[-10].cvs));
      const auto& dpost = *((yyvsp[-6].con_list));
      const auto& id_list = *((yyvsp[-3].ident_list));
      const auto& target = *((yyvsp[-1].mystring));
      check_dpost(paut->dim, dpost, paut->variables);
      for (const auto& id : id_list)
        paut->add_transition(current_loc_name, id, target,
                             guard, dpost, Urgency::urgent);
      delete (yyvsp[-10].cvs);
      delete (yyvsp[-6].con_list);
      delete (yyvsp[-3].ident_list);
      delete (yyvsp[-1].mystring);
    }
#line 3506 "parser.cc" /* yacc.c:1646  */
    break;

  case 144:
#line 1485 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& guard = *((yyvsp[-6].cvs));
      const auto& id_list = *((yyvsp[-3].ident_list));
      const auto& target = *((yyvsp[-1].mystring));
      // controlled variables should remain constant
      Cons dpost = identity_dpost(paut->dim, paut->variables);
      for (const auto& id : id_list)
        paut->add_transition(current_loc_name, id, target,
                             guard, dpost, Urgency::urgent);
      delete (yyvsp[-6].cvs);
      delete (yyvsp[-3].ident_list);
      delete (yyvsp[-1].mystring);
    }
#line 3524 "parser.cc" /* yacc.c:1646  */
    break;

  case 145:
#line 1502 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyvsp[-2].refinement_cons)->push_back(*(yyvsp[0].refinement_con));
      (yyval.refinement_cons) = (yyvsp[-2].refinement_cons);
      delete (yyvsp[0].refinement_con);
    }
#line 3534 "parser.cc" /* yacc.c:1646  */
    break;

  case 146:
#line 1508 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyval.refinement_cons) = new RefinementCons;
      (yyval.refinement_cons)->push_back(*(yyvsp[0].refinement_con));
      delete (yyvsp[0].refinement_con);
    }
#line 3544 "parser.cc" /* yacc.c:1646  */
    break;

  case 147:
#line 1517 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyval.refinement_con) = new RefinementCon;
      (yyval.refinement_con)->con = Con((yyvsp[-3].rae)->aexpr.expr, (yyvsp[-3].rae)->aexpr.inhomo,
                    Con::NONSTRICT_INEQUALITY);
      (yyval.refinement_con)->min_d = (yyvsp[-1].rae)->rat_inhomo_term() * Rational((yyvsp[-3].rae)->den);
      (yyval.refinement_con)->max_d = Rational(0);
      delete (yyvsp[-3].rae);
      delete (yyvsp[-1].rae);
    }
#line 3558 "parser.cc" /* yacc.c:1646  */
    break;

  case 148:
#line 1527 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyval.refinement_con) = new RefinementCon;
      (yyval.refinement_con)->con = Con((yyvsp[-5].rae)->aexpr.expr, (yyvsp[-5].rae)->aexpr.inhomo,
                   Con::NONSTRICT_INEQUALITY);
      (yyval.refinement_con)->min_d = (yyvsp[-3].rae)->rat_inhomo_term() * Rational((yyvsp[-5].rae)->den);
      (yyval.refinement_con)->max_d = (yyvsp[-1].rae)->rat_inhomo_term() * Rational((yyvsp[-5].rae)->den);
      delete (yyvsp[-5].rae);
      delete (yyvsp[-3].rae);
      delete (yyvsp[-1].rae);
    }
#line 3573 "parser.cc" /* yacc.c:1646  */
    break;

  case 149:
#line 1540 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      if (paut == nullptr)
        yyerror("paut not defined");
      else
        val_set_dim = paut->dim;
    }
#line 3584 "parser.cc" /* yacc.c:1646  */
    break;

  case 150:
#line 1547 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { (yyval.cvs) = (yyvsp[0].cvs); }
#line 3590 "parser.cc" /* yacc.c:1646  */
    break;

  case 151:
#line 1550 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      if (paut == nullptr)
        yyerror("paut not defined");
      else
        val_set_dim = 2 * paut->dim;
    }
#line 3601 "parser.cc" /* yacc.c:1646  */
    break;

  case 152:
#line 1557 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    { (yyval.con_list) = (yyvsp[0].con_list); }
#line 3607 "parser.cc" /* yacc.c:1646  */
    break;

  case 153:
#line 1561 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyvsp[-2].cvs)->union_assign(*((yyvsp[0].cvs)));
      (yyval.cvs) = (yyvsp[-2].cvs);
      delete (yyvsp[0].cvs);
    }
#line 3617 "parser.cc" /* yacc.c:1646  */
    break;

  case 154:
#line 1567 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyvsp[-2].cvs)->intersection_assign(*((yyvsp[0].cvs)));
      (yyval.cvs) = (yyvsp[-2].cvs);
      delete (yyvsp[0].cvs);
    }
#line 3627 "parser.cc" /* yacc.c:1646  */
    break;

  case 155:
#line 1573 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyvsp[0].cvs)->negate();
      (yyval.cvs) = (yyvsp[0].cvs);
    }
#line 3636 "parser.cc" /* yacc.c:1646  */
    break;

  case 156:
#line 1578 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyval.cvs) = (yyvsp[-1].cvs);
    }
#line 3644 "parser.cc" /* yacc.c:1646  */
    break;

  case 157:
#line 1582 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& cs = *((yyvsp[0].con_list));
      auto ccvs = convex_clock_val_set(val_set_dim, std::move(cs));
      (yyval.cvs) = new clock_val_set(std::move(ccvs));
      delete (yyvsp[0].con_list);
    }
#line 3655 "parser.cc" /* yacc.c:1646  */
    break;

  case 158:
#line 1593 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyvsp[-2].con_list)->insert((yyvsp[-2].con_list)->end(),
                 std::make_move_iterator((yyvsp[0].con_list)->begin()),
                 std::make_move_iterator((yyvsp[0].con_list)->end()));
      (yyval.con_list) = (yyvsp[-2].con_list);
      delete (yyvsp[0].con_list);
    }
#line 3667 "parser.cc" /* yacc.c:1646  */
    break;

  case 160:
#line 1604 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
       (yyval.con_list) = new Cons;
       (yyval.con_list)->push_back(*(yyvsp[0].con));
       delete (yyvsp[0].con);
     }
#line 3677 "parser.cc" /* yacc.c:1646  */
    break;

  case 161:
#line 1610 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
       (yyval.con_list) = new Cons;
       Affine_Expr ae = ((yyvsp[-4].rae)->den)*((yyvsp[-2].rae)->aexpr) - ((yyvsp[-2].rae)->den)*((yyvsp[-4].rae)->aexpr);
       (yyval.con_list)->push_back(Con(ae.expr, ae.inhomo, Con::NONSTRICT_INEQUALITY));
       ae = ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr) - ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr);
       (yyval.con_list)->push_back(Con(ae.expr, ae.inhomo, Con::NONSTRICT_INEQUALITY));
       delete (yyvsp[-4].rae);
       delete (yyvsp[-2].rae);
       delete (yyvsp[0].rae);
     }
#line 3692 "parser.cc" /* yacc.c:1646  */
    break;

  case 162:
#line 1621 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
       (yyval.con_list) = new Cons;
       Affine_Expr ae = ((yyvsp[-4].rae)->den)*((yyvsp[-2].rae)->aexpr) - ((yyvsp[-2].rae)->den)*((yyvsp[-4].rae)->aexpr);
       (yyval.con_list)->push_back(Con(ae.expr, ae.inhomo, Con::STRICT_INEQUALITY));
       ae = ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr) - ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr);
       (yyval.con_list)->push_back(Con(ae.expr, ae.inhomo, Con::NONSTRICT_INEQUALITY));
       delete (yyvsp[-4].rae);
       delete (yyvsp[-2].rae);
       delete (yyvsp[0].rae);
     }
#line 3707 "parser.cc" /* yacc.c:1646  */
    break;

  case 163:
#line 1632 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
       (yyval.con_list) = new Cons;
       Affine_Expr ae = ((yyvsp[-4].rae)->den)*((yyvsp[-2].rae)->aexpr) - ((yyvsp[-2].rae)->den)*((yyvsp[-4].rae)->aexpr);
       (yyval.con_list)->push_back(Con(ae.expr, ae.inhomo, Con::NONSTRICT_INEQUALITY));
       ae = ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr) - ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr);
       (yyval.con_list)->push_back(Con(ae.expr, ae.inhomo, Con::STRICT_INEQUALITY));
       delete (yyvsp[-4].rae);
       delete (yyvsp[-2].rae);
       delete (yyvsp[0].rae);
     }
#line 3722 "parser.cc" /* yacc.c:1646  */
    break;

  case 164:
#line 1643 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
       (yyval.con_list) = new Cons;
       Affine_Expr ae = ((yyvsp[-4].rae)->den)*((yyvsp[-2].rae)->aexpr) - ((yyvsp[-2].rae)->den)*((yyvsp[-4].rae)->aexpr);
       (yyval.con_list)->push_back(Con(ae.expr, ae.inhomo, Con::STRICT_INEQUALITY));
       ae = ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr) - ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr);
       (yyval.con_list)->push_back(Con(ae.expr, ae.inhomo, Con::STRICT_INEQUALITY));
       delete (yyvsp[-4].rae);
       delete (yyvsp[-2].rae);
       delete (yyvsp[0].rae);
     }
#line 3737 "parser.cc" /* yacc.c:1646  */
    break;

  case 165:
#line 1658 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      Affine_Expr ae = ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr) - ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr);
      auto pcon = new Con(std::move(ae.expr), std::move(ae.inhomo),
                          Con::STRICT_INEQUALITY);
      (yyval.con) = pcon;
      delete (yyvsp[-2].rae);
      delete (yyvsp[0].rae);
    }
#line 3750 "parser.cc" /* yacc.c:1646  */
    break;

  case 166:
#line 1667 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      Affine_Expr ae = ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr) - ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr);
      auto pcon = new Con(std::move(ae.expr), std::move(ae.inhomo),
                          Con::STRICT_INEQUALITY);
      (yyval.con) = pcon;
      delete (yyvsp[-2].rae);
      delete (yyvsp[0].rae);
    }
#line 3763 "parser.cc" /* yacc.c:1646  */
    break;

  case 167:
#line 1676 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      Affine_Expr ae = ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr) - ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr);
      auto pcon = new Con(std::move(ae.expr), std::move(ae.inhomo),
                          Con::NONSTRICT_INEQUALITY);
      (yyval.con) = pcon;
      delete (yyvsp[-2].rae);
      delete (yyvsp[0].rae);
    }
#line 3776 "parser.cc" /* yacc.c:1646  */
    break;

  case 168:
#line 1685 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      Affine_Expr ae = ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr) - ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr);
      auto pcon = new Con(std::move(ae.expr), std::move(ae.inhomo),
                          Con::NONSTRICT_INEQUALITY);
      (yyval.con) = pcon;
      delete (yyvsp[-2].rae);
      delete (yyvsp[0].rae);
    }
#line 3789 "parser.cc" /* yacc.c:1646  */
    break;

  case 169:
#line 1694 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      Affine_Expr ae = ((yyvsp[0].rae)->den)*((yyvsp[-2].rae)->aexpr) - ((yyvsp[-2].rae)->den)*((yyvsp[0].rae)->aexpr);
      auto pcon = new Con(std::move(ae.expr), std::move(ae.inhomo),
                          Con::EQUALITY);
      (yyval.con) = pcon;
      delete (yyvsp[-2].rae);
      delete (yyvsp[0].rae);
    }
#line 3802 "parser.cc" /* yacc.c:1646  */
    break;

  case 170:
#line 1703 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      auto pcon = new Con(Linear_Expr(), 0, Con::EQUALITY);
      (yyval.con) = pcon;
    }
#line 3811 "parser.cc" /* yacc.c:1646  */
    break;

  case 171:
#line 1708 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      auto pcon = new Con(Linear_Expr(), 1, Con::EQUALITY);
      (yyval.con) = pcon;
    }
#line 3820 "parser.cc" /* yacc.c:1646  */
    break;

  case 172:
#line 1716 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& str = *((yyvsp[0].mystring));
      auto prae = new Rat_Affine_Expr(str);
      (yyval.rae) = prae;
      delete (yyvsp[0].mystring);
    }
#line 3831 "parser.cc" /* yacc.c:1646  */
    break;

  case 173:
#line 1723 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[-1].mystring));
      if (paut->var_id_map.contains_name(id)) {
        dim_type vid = paut->var_id_map.get_id(id);
        // Variable is primed: add automaton dim.
        vid += paut->dim;
        auto prae = new Rat_Affine_Expr(Var(vid));
        (yyval.rae) = prae;
      } else
        yyerror("Either variable " + id + " not defined in automaton "
                + paut->name + ", or undefined shortcut.");
      delete (yyvsp[-1].mystring);
    }
#line 3849 "parser.cc" /* yacc.c:1646  */
    break;

  case 174:
#line 1737 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      const auto& id = *((yyvsp[0].mystring));
      if (rae_map.find(id) == rae_map.end()) {
        if (paut != nullptr && paut->var_id_map.contains_name(id)) {
          dim_type vid = paut->var_id_map.get_id(id);
          auto prae = new Rat_Affine_Expr(Var(vid));
          (yyval.rae) = prae;
        } else {
          if (paut != nullptr)
            yyerror("Either variable " + id
                    + " not defined in automaton " + paut->name
                    + ", or undefined shortcut.");
          else
            yyerror("Cannot identify \"" + id +"\".");
        }
      } else {
        auto prae = new Rat_Affine_Expr(rae_map[id]);
        (yyval.rae) = prae;
      }
      delete (yyvsp[0].mystring);
    }
#line 3875 "parser.cc" /* yacc.c:1646  */
    break;

  case 175:
#line 1759 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      if (attempt_multiply(*((yyvsp[-2].rae)),*((yyvsp[0].rae)))) {
        (yyval.rae) = (yyvsp[-2].rae);
        delete (yyvsp[0].rae);
      } else {
        yyerror("Cannot multiply two linear expressions. ");
        cout << *((yyvsp[-2].rae)) << " and " << *((yyvsp[0].rae)) << endl;
      }
    }
#line 3889 "parser.cc" /* yacc.c:1646  */
    break;

  case 176:
#line 1769 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      if (attempt_division(*((yyvsp[-2].rae)),*((yyvsp[0].rae)))) {
        (yyval.rae) = (yyvsp[-2].rae);
        delete (yyvsp[0].rae);
      } else
        yyerror("Cannot divide two linear expressions.");
    }
#line 3901 "parser.cc" /* yacc.c:1646  */
    break;

  case 177:
#line 1777 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      *((yyvsp[-2].rae)) += *((yyvsp[0].rae));
      (yyval.rae) = (yyvsp[-2].rae);
      delete (yyvsp[0].rae);
    }
#line 3911 "parser.cc" /* yacc.c:1646  */
    break;

  case 178:
#line 1783 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      *((yyvsp[-2].rae)) -= *((yyvsp[0].rae));
      (yyval.rae) = (yyvsp[-2].rae);
      delete (yyvsp[0].rae);
    }
#line 3921 "parser.cc" /* yacc.c:1646  */
    break;

  case 179:
#line 1789 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      neg_assign(*(yyvsp[0].rae));
      (yyval.rae) = (yyvsp[0].rae);
    }
#line 3930 "parser.cc" /* yacc.c:1646  */
    break;

  case 180:
#line 1794 "../../../phaver/src/parser.yy" /* yacc.c:1646  */
    {
      (yyval.rae) = (yyvsp[-1].rae);
    }
#line 3938 "parser.cc" /* yacc.c:1646  */
    break;


#line 3942 "parser.cc" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1799 "../../../phaver/src/parser.yy" /* yacc.c:1906  */

